/*EM	CHCASMAP.C - Main Module
 *
 *	SUMMARY
 *	    Basic LibMain and WEP functions
 *
 *	COMMENTS
 *
 *	WARNINGS
 *	    This module may not be unloaded before Windows' session
 *	    termination.
 *
 */


#include "winflags.h"
#undef NOKERNEL
#undef NOMEMMGR
#include <windows.h>

#define SELECTOR_OF(p) HIWORD((void _far *)(p))

VOID FAR PASCAL HookVector(void) ;

BOOL FAR PASCAL LibMain(HANDLE hInstance   /* Library instance handle  */
		       ,WORD wDataSeg	    /* Default data segment	*/
		       ,WORD cbHeap	    /* Default Heap size	*/
		       ,LPSTR lpszCmdLine) ;/* Command line		*/
int FAR PASCAL WEP(int fSystemExit) ;
#pragma alloc_text(INIT_TEXT,LibMain)	/* Keep this with LIBENTRY.ASM	*/
#pragma alloc_text(FIXED_TEXT,WEP)


HANDLE hLibInstance ;

/*XP<	LibMain - Main library entry point.
 *
 *	ENTRY
 *
 *	EXIT
 *
 *	RETURNS
 *	    TRUE if initialization succeeds, FALSE otherwise.
 *
 *	WARNINGS
 *
 *	CALLS
 *
 *	NOTES
 *	    The true library entry point is in the assembly language
 *	    module LIBENTRY.ASM, but it simply passes control to here.
 *
 */
BOOL FAR PASCAL LibMain(HANDLE hInstance   /* Library instance handle  */
		       ,WORD wDataSeg	    /* Default data segment	*/
		       ,WORD cbHeap	    /* Default Heap size	*/
		       ,LPSTR lpszCmdLine)  /* Command line		*/
/*>*/
{
    lpszCmdLine = lpszCmdLine ;     /* Avoid -W4 warnings		*/
    hLibInstance = hInstance ;	    /* We may need this later to access
				       resources from our executable	*/

    if (cbHeap)
	if (LocalInit(wDataSeg, 0, cbHeap) == 0)
	    return FALSE ;		/* Fail if cannot init heap	*/

    UnlockData(0) ;

    HookVector() ;

    return TRUE ;
}



/*XP<	WEP - Windows Exit Procedure
 *
 *	ENTRY
 *	    fSystemExit indicates if we are terminating the Windows
 *	    session.  Otherwise, we are only unloading this DLL.
 *
 *	RETURNS
 *	    Always returns "1".
 *
 *	WARNINGS
 *	    Due to bugs in Windows 3.0 and earlier (and perhaps later),
 *	    this function must be placed in a fixed segment.  This same
 *	    bug makes the value of DS questionable, so we cannot use it
 *	    (or any static data).
 *
 *	    To be sure, we don't do anything here, anyway.
 *
 *	CALLS
 *	    None
 *
 *	NOTES
 *	    This is the standard DLL exit procedure.
 *
 */
int FAR PASCAL WEP(int fSystemExit)
/*>*/
{
    fSystemExit = fSystemExit ;     /* Avoid -W4 warning		*/
    return 1 ;                      /* Always indicate sucess           */
}
