page ,132

; masm tisr ; >err
	.286p
.xlist
include dpmi.h
include pic.h
.list

TIMER_IRQ EQU 0

WM_COMMAND	    = 0111h

EXTRN POSTMESSAGE:FAR

Words struc
LoWord dw ?
HiWord dw ?
Words ends

;
; Set variables for our interrupt number
;
INT_DEV equ (INT_MASTER_0+(TIMER_IRQ AND 7))
PIC00 equ INTA00
PIC01 equ INTA01

page

FIXED_DATA SEGMENT DWORD PUBLIC 'DATA'
PUBLIC _hWndEvent,_wParamEvent,_wCount,_lpfnPrevISR

_hWndEvent label word
hWndEvent dw  0 		; Window to post events to

_wParamEvent label word
wParamEvent dw	0		; wParam value to post

_wCount label word
wCount dw  0			; count of unprocessed interrupts

_lpfnPrevISR label dword	; address of previous ISR
lpfnPrevISR dd 0

FIXED_DATA ENDS

page

;IP	IntSvcRtn - The Interrupt Service Routine
;
;	WARNINGS
;
;	NOTES
;	    This ISR increments a count and re-arms the device.
;	    If the count was previously zero, a message is posted.
;

FIXED_TEXT SEGMENT PARA PUBLIC 'CODE'
selData1    dw	FIXED_DATA
	assume	CS:FIXED_TEXT,DS:NOTHING
PUBLIC _IntSvcRtn
_IntSvcRtn label far
IntSvcRtn proc far
	sub	sp,4		    ; save space for return address
	push	bp
	mov	bp,sp
	push	ax
	push	dx
	push	ds
	mov	ds,selData1
	assume	ds:FIXED_DATA
	inc	wCount

	mov	ax,lpfnPrevISR.LoWord	; store return address
	mov	[bp+2],ax
	mov	ax,lpfnPrevISR.HiWord
	mov	[bp+4],ax

	cmp	hWndEvent,0	    ; exiting?
	jz	isr9		    ; if so, then don't restart or post
	cmp	wCount,1	    ; Need to post?
	jne	isr9		    ; skip if not

	push	bx		    ; save the remaining registers
	push	cx
	push	es

	push	hWndEvent
	push	WM_COMMAND
	push	wParamEvent
	push	0	; lParam is zero
	push	0
	call	POSTMESSAGE	    ; post the event

	pop	es
	pop	cx
	pop	bx

isr9:
	pop	ds
	assume	ds:NOTHING
	pop	dx
	pop	ax
	leave
	retf
IntSvcRtn endp


FIXED_TEXT ENDS


	end
